<?php


namespace MirfalahTech\Laravel\Payment\Facade;


use Illuminate\Http\Request;
use Illuminate\Support\Facades\Facade;
use MirfalahTech\Laravel\Payment\Contracts\PayableEntity;
use MirfalahTech\Laravel\Payment\Contracts\PaymentGatewayDriver;
use Symfony\Component\HttpFoundation\Response;

/**
 * Class Payment
 * @package MirfalahTech\Laravel\Payment\Facade
 *
 * @method static PaymentGatewayDriver via(string $gateway = null)
 * @method static string createPaymentURL(PayableEntity $payable, array $options = [])
 * @method static bool verifyGatewayReturn(Request $request)
 * @method static bool verifyGatewayCallback(Request $request, Response &$response = null)
 */
class Payment extends Facade
{
    protected static function getFacadeAccessor()
    {
        return 'payment';
    }
}
